=== debian/changelog ===
rustc (1.25.0+dfsg1+llvm-0ubuntu1~17.10.1) artful; urgency=medium

  * Backport 1.25.0 to artful

 -- Chris Coulson <chris.coulson@canonical.com>  Mon, 23 Apr 2018 16:33:35 +0100

rustc (1.25.0+dfsg1+llvm-0ubuntu1) bionic; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Only build debuginfo for libstd on i386
      - update debian/rules
    - Ensure the build uses the bundled stage0 rustc when bootstrapping
      - update debian/rules
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Make RustdocTheme test work on builds where rust.rpath = false
      - add debian/patches/u-fix-rustdoc-theme-test-without-rpath.patch
      - update debian/patches/series
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests. This isn't a proper fix and needs further
      investigation
      - update debian/control
    - Ignore test failures on Aarch64. Upstream aren't even running tests on
      this architecture so let's not care about test failures there
      - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 10 Apr 2018 16:12:33 +0100

rustc (1.25.0+dfsg1-1~exp2) experimental; urgency=medium

  * Install missing codegen-backends.

 -- Ximin Luo <infinity0@debian.org>  Fri, 06 Apr 2018 14:05:36 -0700

rustc (1.25.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update to LLVM 6.0.

 -- Ximin Luo <infinity0@debian.org>  Sun, 01 Apr 2018 15:59:47 +0200
