## rustc 1.28.0+dfsg1+llvm

=== debian/changelog ===
rustc (1.28.0+dfsg1+llvm-0ubuntu2) cosmic; urgency=medium

  * Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an upgrade
    issue
    - update debian/control

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 21 Aug 2018 23:31:55 +0100

rustc (1.28.0+dfsg1+llvm-0ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable, remaining changes: 
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 14 Aug 2018 21:57:50 +0100

rustc (1.28.0+dfsg1-2) unstable; urgency=medium

  * Switch on verbose-tests to restore the old pre-1.28 behaviour, and restore
    old failure-counting logic.
  * Allow 50 test failures on s390x, restored failure-counting logic avoids
    more double-counts.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Aug 2018 02:18:10 -0700

rustc (1.28.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Add patches from Fedora to fix some test failures.
  * Ignore a failure testing specific error output, under investigation.
  * Allow 100 test failures on s390x, should be reducible later with LLVM 7.
  * Temporary fix for mips64el bootstrap.
  * Be even more verbose during the build.
  * Update to latest Standards-Version.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Aug 2018 23:04:41 -0700

rustc (1.28.0~beta.14+dfsg1-1~exp2) experimental; urgency=medium

  * Update test-failure counting logic.
  * Fix version constraints for Recommends: cargo.
  * Add patch to fix sparc64 CABI.

 -- Ximin Luo <infinity0@debian.org>  Fri, 27 Jul 2018 04:26:52 -0700

rustc (1.28.0~beta.14+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Jul 2018 03:11:11 -0700

rustc (1.27.2+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * Update of the alioth ML address.

  [ Ximin Luo ]
  * Fail the build if our version contains ~exp and we are not releasing to
    experimental, this has happened by accident a few times already.
  * Allow 36 and 44 test failures on armel and s390x respectively.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 24 Jul 2018 21:35:56 -0700

rustc (1.27.1+dfsg1-1~exp4) experimental; urgency=medium

  * Unconditonally prune crate checksums to avoid having to manually prune them
    whenever we patch the vendored crates.

 -- Ximin Luo <infinity0@debian.org>  Thu, 19 Jul 2018 14:49:18 -0700

rustc (1.27.1+dfsg1-1~exp3) experimental; urgency=medium

  * Add patch from Fedora to fix rebuild against same version.

 -- Ximin Luo <infinity0@debian.org>  Thu, 19 Jul 2018 08:52:03 -0700

rustc (1.27.1+dfsg1-1~exp2) experimental; urgency=medium

  * Fix some failing tests.

 -- Ximin Luo <infinity0@debian.org>  Wed, 18 Jul 2018 09:06:44 -0700

rustc (1.27.1+dfsg1-1~exp1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 13 Jul 2018 22:58:02 -0700

rustc (1.27.0+dfsg0+llvm-0ubuntu1) cosmic; urgency=medium

  * Update to 1.27.0
  * Bump rustc build requirement to 1.26.0
    - update debian/control
  * Rename libstd-rust-1.26 to libstd-rust-1.27
    - update debian/control
    - debian/libstd-rust-1.26.lintian-overrides =>
        debian/libstd-rust-1.27.lintian-overrides
  * Update debian/copyright
  * Refresh patches
    - update debian/patches/u-fixtestignores-ppc64el.patch
    - update debian/patches/u-tag-private-modules-with-doc-cfg.patch
    - update debian/patches/d-disable-cargo-vendor.patch
    - update debian/patches/d-no-web-dependencies-in-doc.patch
  * Drop patches that are fixed upstream
    - remove debian/patches/u-fix-rustdoc-theme-test-without-rpath.patch
    - remove debian/patches/u-fix-fp-target-warning.patch
    - update debian/patches/series
  * Disable search functionality in the documentation as it depends on
    mark.js and elasticlunr.js, both of which are stripped from the tarball
    (they are vendored in minified form) and neither of which are packaged
    separately in Ubuntu yet
    - add debian/patches/d-disable-doc-search.patch
    - update debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 06 Jul 2018 17:02:31 +0100

rustc (1.26.2+dfsg1+llvm-0ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable, remaining changes: 
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Exclude src/tools/lld from the tarball
      - update debian/copyright
      - update debian/rules
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules

