=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
+XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
  Luca Bruno <lucab@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>,
@@ -13,11 +13,10 @@
                dpkg-dev (>= 1.17.14),
                python:native,
                cargo:native (>= 0.19.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.24.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.25.0++)    <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.27.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.28.0++)    <!pkg.rustc.dlstage0>,
                autotools-dev,
                cmake (>= 3.0) | cmake3,
-               gperf,
 # this is sometimes needed by rustc_llvm
                zlib1g-dev:native,
                zlib1g-dev,
@@ -38,10 +37,9 @@
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
                curl <pkg.rustc.dlstage0>,
                ca-certificates <pkg.rustc.dlstage0>,
-Build-Conflicts: gdb-minimal <!nocheck>,
-                 rustc:native (= 1.25.0+dfsg1-1~exp1)
+Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 # ^ That version of rustc is broken
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://salsa.debian.org/rust-team/rust.git
 Vcs-Browser: https://salsa.debian.org/rust-team/rust
@@ -52,8 +50,10 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: rust-gdb | rust-lldb
+Recommends: cargo (>= 0.29.0~~), cargo (<< 0.30.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src
+Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
+Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -67,7 +67,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.25
+Package: libstd-rust-1.28
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -92,7 +92,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libstd-rust-1.25 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.28 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
