=== debian/rules ===
--- 
+++ 
@@ -10,27 +10,21 @@
 LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
 # Sed expression that matches the "rustc" we have in our Build-Depends field
 SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
+# Version of /usr/bin/rustc
+LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')
 
 include /usr/share/dpkg/buildflags.mk
 # TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
 RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
-# set remap-path-prefix for reproducible builds; TODO: remove "if" after 1.20
-ifeq (0,$(shell dpkg --compare-versions "$$(rustc --version --verbose | sed -ne 's/^release: //p')" '>=' 1.19.0; echo $$?))
-RUSTFLAGS += -Zremap-path-prefix-from=$(CURDIR) -Zremap-path-prefix-to=/usr/src/rustc-$(RUST_LONG_VERSION)
-export RUSTC_BOOTSTRAP = 1
+RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
+ifneq (,$(filter $(DEB_BUILD_ARCH), sparc64))
+export CARGO_INCREMENTAL = 0
 endif
 
 # Defines DEB_*_RUST_TYPE triples
 include debian/architecture.mk
 export DEB_HOST_RUST_TYPE
-
-# Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
-
-# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
-# gcc-6.  See bug #811573.
-CFLAGS += -Wno-misleading-indentation
 
 # Let rustbuild control whether LLVM is compiled with debug symbols, rather
 # than compiling with debug symbols unconditionally, which will fail on
@@ -38,17 +32,13 @@
 CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
 CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
 
-# Release type (one of beta, stable or nightly)
-RELEASE_CHANNEL := stable
-# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
-# out of this packaging. Furthermore, if the build breaks after importing a new
-# upstream stable release, check the do_temporary_fixup function in that file
-# to see if we already know what fix to make.
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 RUSTBUILD = RUST_BACKTRACE=1 ./x.py
-RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
+RUSTBUILD_FLAGS = --config debian/config.toml -vv --on-fail env
 # TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
 # an insane blow up in the time it takes to run tests. See upstream #37477 for
 # details. Upstream worked around it in #38984 but in Debian we can't take
@@ -65,14 +55,14 @@
 update-version:
 	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
 	newver=$(RUST_VERSION); \
-	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi
+	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)
 
 # Below we detect how we're supposed to bootstrap the stage0 compiler. See
 # README.Debian for more details of the cases described below.
 #
 PRECONFIGURE_CHECK = :
 HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
-ENABLE_LOCAL_RUST := false
+DOWNLOAD_BOOTSTRAP := false
 # allow not using the binary tarball although it exists
 #ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
 #  HAVE_BINARY_TARBALL := 0
@@ -86,7 +76,6 @@
     # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
     # In this case, we use the distro's rustc - either the previous or current version.
     ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
-        ENABLE_LOCAL_RUST := true
         # Make it easier to test against a custom rustc
         ifneq (,$(RUST_DESTDIR))
         RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
@@ -98,6 +87,7 @@
     # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
     # We don't need to do anything specific in this build file, so this case is empty.
     else
+        DOWNLOAD_BOOTSTRAP := true
     endif
 else
     # Case B (Bootstrapping a new distro): the extracted source tree does
@@ -126,8 +116,7 @@
 endif
 
 # Build products or non-source files in src/, that shouldn't go in rust-src
-SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
-	src/bootstrap/bootstrap.pyc \
+SRC_CLEAN = src/bootstrap/bootstrap.pyc \
 	src/etc/__pycache__/
 
 # Workaround for linux #865549
@@ -146,16 +135,20 @@
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig
 
-debian/config.toml: debian/config.toml.in
+debian/config.toml: debian/config.toml.in debian/rules
+	u="$(DEB_VERSION_UPSTREAM)"; \
+	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
+	else channel="stable"; fi; echo $$channel; \
 	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
 		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
 		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
-		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
+		-DRELEASE_CHANNEL="$$channel" \
 		-DBUILD_DOCS="$(BUILD_DOCS)" \
 		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
 		"$<" > "$@"
-	$(ENABLE_LOCAL_RUST) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
+	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
+	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 	# Work around armhf issue: https://github.com/rust-lang/rust/issues/45854
 	[ $(DEB_BUILD_ARCH) != armhf -a \
 	  $(DEB_BUILD_ARCH) != armel -a \
@@ -166,15 +159,21 @@
 		"$<" > "$@"
 
 override_dh_auto_configure: debian/config.toml
+	# fail the build if our version contains ~exp and we are not releasing to experimental
+	v="$(DEB_VERSION)"; test "$$v" = "$${v%~exp*}" -o "$(DEB_DISTRIBUTION)" = "experimental" -o "$(DEB_DISTRIBUTION)" = "UNRELEASED"
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
-	# We patched mdbook so have to rm the checksums
-	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
+	# We patched some crates so have to rm the checksums
+	find src/vendor -name .cargo-checksum.json -execdir "$(CURDIR)/debian/prune-checksums" "{}" ";"
 	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
 	# compile it again for rust-installer, see #43449
 	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
-	debian/prune-checksums src/vendor/backtrace-sys/.cargo-checksum.json
 	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16
+	echo 'fn main() { println!("cargo:rustc-link-lib=lzma"); }' > src/vendor/lzma-sys/build.rs
+	# We don't run ./configure because we use debian/config.toml directly
+	ln -sf debian/config.toml config.toml
+
+override_dh_auto_clean:
